class MSBAction_SetPropertyText extends ScriptedAction;

var string Prop;
var string setTo;
var Actor Target;
var array<string> Parts;


function bool InitActionFor(ScriptedController C)
{
local vector Loc;
local rotator Rotat;

if (Prop=="Location")
  {
  Split(setTo,",",Parts);
  if (Parts.length>2)
    {
    Loc.X=float(Parts[0]);
    Loc.Y=float(Parts[1]);
    Loc.Z=float(Parts[2]);
    Target.SetLocation(Loc);
    }
  }
else if (Prop=="Rotation")
  {
  Split(setTo,",",Parts);
  if (Parts.length>2)
    {
    Rotat.Pitch=int(Parts[0]);
    Rotat.Yaw=int(Parts[1]);
    Rotat.Roll=int(Parts[2]);
    Target.SetRotation(Rotat);
    }
  }
else
  {
  Target.SetPropertyText(Prop,"None");
  Target.SetPropertyText(Prop,setTo);
  }

return false;
}


