//-----------------------------------------------------------
// Spawns new Buttons
//-----------------------------------------------------------
class MSB2DSpawnButton extends MSBTwoStepButton;

var class <MSBGuiOverlay> SpawnActorClass;
var string SpawnActorClassName;
var MSBGuiOverlay SpawnActor;

function LeftBtn(Canvas C)
{
super.LeftBtn(C);

if (SpawnActorClass==None)
  SpawnActorClass = class<MSBGuiOverlay>(DynamicLoadObject(SpawnActorClassName, class'Class'));
SpawnActor = spawn(SpawnActorClass);
SpawnActor.bEnabled=false;
}

function LeftBtnFinished(Canvas C)
{
super.LeftBtnFinished(C);
SpawnActor.bEnabled=true;
SpawnActor=None;
}

function RightBtn(Canvas C)
{
super.RightBtn(C);
if (SpawnActor!=None)
  SpawnActor.Destroy();
super.LeftBtnFinished(C);
}

function initButton (Canvas C)
{
super.initButton(C);
C.SetPos(xPos,yPos);
C.FontScaleX=buttonFontScale;
C.FontScaleY=buttonFontScale;
C.DrawText(BtnName);
C.FontScaleX=fontScale;
C.FontScaleY=fontScale;
if (SpawnActor!=None)
  {
  SpawnActor.xPos=Mouse.xPos;
  SpawnActor.yPos=Mouse.yPos;
  }
}

DefaultProperties
{
tooltip1="Spawn 2D"
tooltip2="Place Object"
width=96
height=20
SpawnActorClassName="MSBCode.MSBListButton"
col=(R=225,G=225,B=255,A=255)
}
