class MSBInterAction extends Interaction;

var MSBMouseOverlay Mouse;
var MSBController M;

// from Console
var string TypedStr;           // Holds the current command, and the history
var int TypedStrPos;		   //Current position in TypedStr
var bool bTyping;			   // Turn when someone is typing on the console

//
var int keyPressed;

function Initialize()
{
        //crosslink with PlayerController
        M=MSBController(ViewportOwner.Actor);
        M.MInteract=self;
        Log ("Mouse Interface Interaction initializes");
}

function bool KeyEvent (EInputKey Key, EInputAction Action, float Delta)
{
Mouse.bTyping=bTyping;
keyPressed=Key;
if (bTyping)
  {
    if( Key==IK_Enter)
		{
            //Mouse.pressedKey=0;
            Mouse.btnOne=true;
            bTyping=false;
            TypedStrPos=0;
            Mouse.xPos+=64;
		}
	if( Key==IK_Backspace && TypedStrPos > 0 )
		{
			TypedStr = Left(TypedStr,TypedStrPos-1)$Right(TypedStr, Len(TypedStr) - TypedStrPos);
			TypedStrPos--;
		}
	if (Key==IK_Delete && TypedStrPos < Len(TypedStr))
			TypedStr = Left(TypedStr,TypedStrPos)$Right(TypedStr, Len(TypedStr) - TypedStrPos - 1);
    if ( Key==IK_Left )
		TypedStrPos = Max(0, TypedStrPos - 1);
    if ( Key==IK_Right )
		TypedStrPos = Min(Len(TypedStr), TypedStrPos + 1);
	if ( Key==IK_Home )
		TypedStrPos = 0;
	if ( Key==IK_End )
		TypedStrPos = Len(TypedStr);
    if (Key==27) //escape
      {
        Mouse.bEsc=true;
//        Mouse.btnOne=true;
        bTyping=false;
        TypedStrPos=0;
        Mouse.xPos+=64;
        Mouse.releasedKey=int(Key);
      }

  Mouse.SetPropertyText("TextInput",TypedStr);
  }

if (Action==IST_Press)
  {
  if(Key==1);
  if(Key==2);
  if(Key==16) //Shift
    Mouse.bShiftDown=true;

  Mouse.pressedKey=int(Key);
  }

if (Action==IST_Release)
  {
  if(Key==1)
    Mouse.btnOne=true;
  if(Key==2)
    Mouse.btnTwo=true;
  if(Key==16)  //shift
    {
    Mouse.bShiftDown=false;
    Mouse.bShiftRelease=true;
    }
  if(Key==18)  //Alt
    M.switchStates();

  if(Key==46) //del
    Mouse.bDeleteDown=true;
  if (Key==32) //Space
    M.ConsoleCommand("RunMovie");

  if (Key==27) //escape
    Mouse.bEsc=true;

  Mouse.releasedKey=int(Key);
  }
if (Action==IST_Axis);

MSBHud(M.myHUD).debugString=string(Key);
return false;
}


function bool KeyType( EInputKey Key, optional string Unicode )
{
  if (bTyping)
  	if( Key>=0x20 )
	{
		if( Unicode != "" )
			TypedStr = Left(TypedStr, TypedStrPos) $ Unicode $ Right(TypedStr, Len(TypedStr) - TypedStrPos);
		else
			TypedStr = Left(TypedStr, TypedStrPos) $ Chr(Key) $ Right(TypedStr, Len(TypedStr) - TypedStrPos);
		TypedStrPos++;
        return( true );
	}
 	return false;
}


