class MSBNodeInButton extends MSBTwoStepButton;

var MSBNodeOutButton ParentNode;
var MSBNodeButton myNode;

var color lineColor;
var int lineXLength;
var float lineYLength;

#exec texture Import File=Textures\NodeIO.tga Name=NodeIO_Icon Mips=Off Alpha=1

function LeftBtnFinished(Canvas C)
{
super.LeftBtnFinished(C);
if (Mouse.hudTargetActor!=None && Mouse.hudTargetActor.IsA('MSBNodeOutButton'))
  {
  //clear Old Connections and establish new ones
  if (!Mouse.bShiftDown)  //multilink when Shift is pressed
    ClearLinks();
  ParentNode=MSBNodeOutButton(Mouse.hudTargetActor);
  ParentNode.ClearLinks();
  ParentNode.ChildNode=self;
  if (ParentNode.myNode!=None)
    ParentNode.myNode.Order.OurNextScript=myNode.Order;
  else
    ParentNode.myScript.Order.OurNextScript=myNode.Order;
  }

if (Mouse.hudTargetActor==None)
    ClearLinks();
}

function ClearLinks()
{
if (ParentNode!=None)
 {
 ParentNode.ChildNode=None;
 if (ParentNode.myNode!=None)
   ParentNode.myNode.Order.OurNextScript=None;
 else
   ParentNode.myScript.Order.OurNextScript=None;
 ParentNode=None;
 }
}

function initButton(Canvas C)
{
xPos=myNode.xPos;
yPos=myNode.yPos-height;
super.initButton(C);
}


defaultproperties
{
tooltip1="Link to Parent"
tooltip2="select Parent Node"
Mat=Material'NodeIO_Icon'
width=20
height=20
lineColor=(R=0,G=0,B=0,A=255)
}
