class MSBNodeOutButton extends MSBTwoStepButton;

var MSBNodeInButton ChildNode;
var MSBNodeButton myNode;
var MSBScriptNodeButton myScript;

var color lineColor;
var int lineXLength;
var float lineYLength;

var bool drawLink;       //NodeButton collapsing

#exec texture Import File=Textures\NodeIO.tga Name=NodeIO_Icon Mips=Off Alpha=1

function LeftBtnFinished(Canvas C)
{
super.LeftBtnFinished(C);
if (Mouse.hudTargetActor!=None && Mouse.hudTargetActor.IsA('MSBNodeInButton'))
  {
  Log("found NodeIn");
  ClearLinks();
  ChildNode=MSBNodeInButton(Mouse.hudTargetActor);
  ChildNode.ClearLinks();
  ChildNode.ParentNode=self;
  if (myNode!=None)
    myNode.Order.OurNextScript=ChildNode.myNode.Order;
  else
    myScript.Order.OurNextScript=ChildNode.myNode.Order;
  }
if (Mouse.hudTargetActor==None)
  ClearLinks();
}


function initButton(Canvas C)
{
if (myNode!=None)
  {
  xPos=myNode.xPos+myNode.width-width;
  yPos=myNode.yPos+myNode.height;
  }
else
  {
  xPos=myScript.xPos+myScript.width-width;
  yPos=myScript.yPos+myScript.height;
  }
super.initButton(C);
}

function Render(Canvas C)
{
local float hLength,
            hSplitPos,
            vSplitPos,
            vLength;
super.Render(C);

if (ChildNode!=None && drawLink)  //draw Link
  {
  hLength=ChildNode.xPos+ChildNode.width/2-(xPos+width);
  hSplitPos=hLength/2+xPos+width;
  vLength=ChildNode.yPos+ChildNode.height/2-(yPos+height/2);
  vSplitPos=ChildNode.yPos+ChildNode.height/2;

  C.SetPos(xpos+width,ypos+height/2);
  C.DrawRect(Texture'engine.WhiteSquareTexture', hLength/2, 1);

  C.SetPos(hSplitPos,ypos+height/2);
  C.DrawRect(Texture'engine.WhiteSquareTexture', 1, vLength);

  C.SetPos(hSplitPos,vSplitPos);
  C.DrawRect(Texture'engine.WhiteSquareTexture', hLength/2, 1);
  }
}


function ClearLinks()
{
if (ChildNode!=None)
  {
  ChildNode.ParentNode=None;
  if (myNode!=None)
    myNode.Order.OurNextScript=None;
  else
    myScript.Order.OurNextScript=None;
  ChildNode=None;
  }
}


defaultproperties
{
drawLink=true
tooltip1=""
tooltip2=""
Mat=Material'Node_Icon'
width=32
height=20
lineColor=(R=0,G=0,B=0,A=255)
}
