//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBSceneEditorHud extends MSBHud;

function PostRender(Canvas C)
{
local int i;
super.PostRender(C);
//-------------------------------------------------
// Editing Mode - drawing Nodes on Hud
//-------------------------------------------------
if (DrawOverlays)
  {
// check DepthOfFieldstuff
  if (dofOverlay.bReady)
    dofOverlay.disableOverlays();

// first draw the MainMenu
    for (i = 0; i < Overlays.length; i++)
      if (Overlays[i].IsA('MSBGuiOverlay') &&  MSBGuiOverlay(Overlays[i]).bMainMenu)
        Overlays[i].Render(C);

// then draw Nodes
    for (i = 0; i < Overlays.length; i++)
      if (Overlays[i].IsA('MSBNodeButton'))
        Overlays[i].Render(C);

// then draw the NodeOuts
    for (i = 0; i < Overlays.length; i++)
      if (Overlays[i].IsA('MSBNodeOutButton'))
        Overlays[i].Render(C);
//then draw the rest
    for (i = 0; i < Overlays.length; i++)
      {
      if (!Overlays[i].isA('MSBGuiOverlay'))
          Overlays[i].Render(C);
      else if (!Overlays[i].IsA('MSBNodeButton') && !MSBGuiOverlay(Overlays[i]).bMainMenu)
        Overlays[i].Render(C);
      }
//if viewed from another actor, reset viewtarget
  if (M.ViewTarget!=M)
     {
     M.Reset();
     M.GotoState('MSBCode');
     }
  }

//-----------------------------------------------------------------
// Run Mode - draw only permanent Overlays and DepthOfField stuff
//----------------------------------------------------------------
else
  {
// Render permanent Buttonoverlays
  for (i = 0; i < Overlays.length; i++)
    if (MSBGuiOverlay(Overlays[i]).bPermanent)
      Overlays[i].Render(C);
// Render User Overlays
  for (i=0;i<UserOverlays.length;i++)
    if (UserOverlays[i].Tex!=None)
      UserOverlays[i].Render(C);
//Render DepthOfField
  if (M.ViewTarget.IsA('MSBCamera') && MSBCamera(M.ViewTarget).bDepth)
     {
     dofOverlay.MSC=MSBCamera(M.ViewTarget);
     if (!dofOverlay.bReady)
       dofOverlay.iniOverlays();
     dofOverlay.Render(C);
     }
  }
MouseOverlay.hudTargetActor=None;
}

DefaultProperties
{
MenuButtons(0)="MSBCode.MSBNaviButton";
MenuButtons(1)="MSBCode.MSBMenuButtonActor";
MenuButtons(2)="MSBCode.MSBMenuButtonStatic";
MenuButtons(3)="MSBCode.MSBMenuButtonSystem";
MenuButtons(4)="MSBCode.MSBMenuButtonNodes";
}
