class MSBPropertyButtonText extends MSBPropertyButton;

var  MSBScriptNode S;
var string typedValue;

function InitButton(Canvas C)
{
super.InitButton(C);
C.SetPos(xpos+width,ypos);
if (hasClicked && Mouse.bTyping)
 {
 Value=Mouse.TextInput;
 C.DrawText(Value);
 C.SetPos(xPos,yPos);
 }
}

function MouseOver(Canvas C)
{
local string drawValue;

super.MouseOver(C);
if (!Mouse.bTyping)
  {
   C.SetPos(xpos+width,ypos);
   drawValue="";
   if (Parent.IsA('MSBNodeButton'))
     drawValue=MSBNodeButton(Parent).Order.GetPropertyText(Property);
   else
     drawValue=Parent.GetPropertyText(Property);
   C.DrawText(drawValue);
  }
}


function LeftBtn(Canvas C)
{
super.LeftBtn(C);
Mouse.bTyping=true;
M.MInteract.bTyping=true;
M.MInteract.TypedStrPos=Len(Value);
}

function LeftBtnFinished(Canvas C)
{
super.LeftBtnFinished(C);
if (Parent.IsA('MSBNodeButton'))
  MSBNodeButton(Parent).Order.SetPropertyText(Property, Value);
Parent.SetPropertyText(Property, Value);
Parent.Trigger(self,None);
Value="";
}

defaultproperties
{
tooltip2="Type in Value"
}

