//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBPlayAniNode extends MSBScriptNode;

var string AniName;
var float AniRate;

function fillsequence()
{
local Action_PLAYANIM pa;
local MSBAction_PlaySpriteAnim ps;
local MSBAction_SpriteAnimEnd sae;
local Action_WaitForTimer wft;
local Action_WaitForAnimEnd wfae;

local float aniLength;
local texture texCount;

local int i;

Super.fillsequence();

 // set Properties for our Actions

Log(AniName);

if (sP!=None)
  {
  ps=new (None) class'MSBAction_PlaySpriteAnim';
  wft=new (None) class'Action_WaitForTimer';
  sae=new (None) class'MSBAction_SpriteAnimEnd';
  sae.sP=sP;
  ps.sP=sP;
  ps.AnimRate=AniRate;

  for (i=0;i<sP.aniname.length;i++)       // check if animation exists
    {
     if (sP.Aniname[i].Angle[3]==AniName)
       {
       ps.AniMat[0]=Material(DynamicLoadObject(sP.Aniname[i].Angle[0],class'Material',true));
       ps.AniMat[1]=Material(DynamicLoadObject(sP.Aniname[i].Angle[1],class'Material',true));
       ps.AniMat[2]=Material(DynamicLoadObject(sP.Aniname[i].Angle[2],class'Material',true));
       ps.AniMat[3]=Material(DynamicLoadObject(sP.Aniname[i].Angle[3],class'Material',true));
       }
    }

  for (texCount=texture(ps.AniMat[3]);texCount!=None;texCount=texCount.AnimNext)
    aniLength+=1;
  Log("From PlayAniNode:AniLength:"@Anilength);
  if (AniRate==0)
    AniRate=texture(ps.AniMat[3]).MaxFrameRate;
  ps.AnimRate=AniRate;
  anilength=anilength/AniRate;
  wft.PauseTime=aniLength;
  Log("From PlayAniNode:PauseTime:"@wft.PauseTime);

  Actions[0]=ps;
  Actions[1]=wft;
  Actions[2]=sae;
  }
else
  {
  pa=new (None) class'Action_PLAYANIM';
  wfae=new(None) class'Action_WaitForAnimEnd';
  pa.SetPropertyText("BaseAnim",AniName);
  pa.AnimRate=AniRate;
  Actions[0]=pa;
  Actions[1]=wfae;
  }
}

defaultproperties
{
 Description="AniName"
}

