//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBExtendedListButton extends MSBListButton;

var bool bDragged;
var bool rHasClickedAgain;
var bool bDisplayed;
var float xDist,yDist;
var array<string> Properties;
var Actor Parent;

function initButton(Canvas C)
{
if (bDragged)
  {
  xPos=Mouse.xPos+xDist;
  yPos=Mouse.yPos+yDist;
  }

super.initButton(C);

C.SetPos(xPos,yPos);
C.SetDrawColor(255,255,255);

C.FontScaleX=buttonFontScale;
C.FontScaleY=buttonFontScale;
C.DrawText(BtnName);
C.FontScaleX=fontScale;
C.FontScaleY=fontScale;

if (bEnabled)
 {
 if (rHasClicked && Mouse.btnTwo)
   {
   rHasClickedAgain=true;
   RightBtnFinished(C);
   rHasClickedAgain=false;
   }
 }
}

function LeftBtn(Canvas C)
{
local int i;

super.LeftBtn(C);
for (i=0;i<Buttonlist.Length; i++)
  {
   MSBPropertyButton(ListButton[i]).Parent=self;
   MSBPropertyButton(ListButton[i]).Property=Properties[i];
  }
}

function RightBtn(Canvas C)
{
super.RightBtn(C);
bDragged=true;
xDist=xPos-Mouse.xPos;
yDist=yPos-Mouse.yPos;

}

function RightBtnFinished(Canvas C)
{
local int i;

rHasClicked=false;
//enable all other buttons after second press
for (i=0;i<M.myHud.Overlays.Length-1;i++)
  if (M.myHud.Overlays[i].IsA('MSBGuiOverlay'))
    MSBGuiOverlay(M.myHud.Overlays[i]).bEnabled=true;

Mouse.btnTwo=false;
bDragged=false;
}

DefaultProperties
{

}
