//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBPoseLoadButton extends MSBListButton;

var string loadName;
var MSBPoseEditor Parent;

event PostBeginPlay()
{
local int i;
super.PostBeginPlay();
for (i=0;i<M.SavePoses.length;i++)
  ButtonList[i]="MSBPropertyButtons.MSBPropertyButtonAssign";
}

function LeftBtn(Canvas C)                      //spawns subButtons
{
local int i;
super.LeftBtn(C);
Parent.ListButton[4].deSelect();

for (i=currentpage*0;i<maxButtons; i++)
  {
   MSBPropertyButton(ListButton[i]).Property="LoadName";
   MSBPropertyButton(ListButton[i]).BtnName=M.SavePoses[i];
   MSBPropertyButton(ListButton[i]).Parent=self;
  }
}


function initButton(Canvas C)
{
super.initButton(C);

C.SetPos(xPos,yPos);
C.FontScaleX=buttonFontScale;
C.FontScaleY=buttonFontScale;
C.DrawText(BtnName);
C.FontScaleX=fontScale;
C.FontScaleY=fontScale;
}


event Trigger(Actor Other, Pawn EventInstigator)
{
local int i;
local MSBAniKey A;
Log("loading Pose!");
for (i=0;i<Parent.lastbone;i++)
  {
  A=Level.Game.LoadDataObject(class'MSBAniKey',loadname$"Key"$i,"MovieSandboxPoses");
  Parent.Pose.PoseKey[i].BoneRotation=A.BoneRotation;
  A=None;
  Parent.Pose.PoseKey[i].KeyActor=Parent.PoseActor;
  Parent.Pose.PoseKey[i].changeBoneRotation();
  }

}



DefaultProperties
{
width=64
height=12
BtnName="LoadPose"
tooltip="Load a Pose"
}
