//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBClearMasterButton extends MSBTwoStepButton;

#exec texture Import File=Textures\clearMaster.tga Name=clearMaster_Icon Mips=Off Alpha=1

var MSBVoxelEdController CC;

event PostBeginPlay()
{
super.PostBeginPlay();
CC=MSBVoxelEdController(M);
}

function LeftBtnFinished(Canvas C)
{
super.LeftBtnFinished(C);
if (Mouse.worldMSBTargetActor.IsA('MSBMasterBlock'))
  {
  CC.Master=MSBMasterBlock(Mouse.worldMSBTargetActor);
  CC.Master.clearBlocks();
  }
}

DefaultProperties
{
tooltip1="clear Master Block"
tooltip2="Select Master Block"
Mat=clearMaster_Icon
}
